//+------------------------------------------------------------------+
//|                                  Moving Averages_With_Frames.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

#include <Trade\Trade.mqh>

input double MaximumRisk        = 0.02;    // հٷ
input double DecreaseFactor     = 3;       // ½
input int    MovingPeriod       = 12;      // ƶƽ
input int    MovingShift        = 6;       // ƶƽת
//---
int   ExtHandle=0;
//+------------------------------------------------------------------+
//| Ż                                       |
//+------------------------------------------------------------------+
double TradeSizeOptimized(void)
  {
   double price=0.0;
   double margin=0.0;
//--- ѡ
   if(!SymbolInfoDouble(_Symbol,SYMBOL_ASK,price))               return(0.0);
   if(!OrderCalcMargin(ORDER_TYPE_BUY,_Symbol,1.0,price,margin)) return(0.0);
   if(margin<=0.0)                                               return(0.0);

   double lot=NormalizeDouble(AccountInfoDouble(ACCOUNT_FREEMARGIN)*MaximumRisk/margin,2);
//--- 𶩵
   if(DecreaseFactor>0)
     {
      //--- ѡҪʵʷ
      HistorySelect(0,TimeCurrent());
      //---
      int    orders=HistoryDealsTotal();  // ܹʷɽ
      int    losses=0;                    // 𶩵

      for(int i=orders-1;i>=0;i--)
        {
         ulong ticket=HistoryDealGetTicket(i);
         if(ticket==0)
           {
            Print("HistoryDealGetTicket ʧ, ûнʷ");
            break;
           }
         //--- 齻Ʒ
         if(HistoryDealGetString(ticket,DEAL_SYMBOL)!=_Symbol) continue;
         //--- 
         double profit=HistoryDealGetDouble(ticket,DEAL_PROFIT);
         if(profit>0.0) break;
         if(profit<0.0) losses++;
        }
      //---
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//--- 淶
   double stepvol=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
   lot=stepvol*NormalizeDouble(lot/stepvol,0);

   double minvol=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
   if(lot<minvol) lot=minvol;

   double maxvol=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);
   if(lot>maxvol) lot=maxvol;
//--- ؽ
   return(lot);
  }
//+------------------------------------------------------------------+
//| 齨                               |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   MqlRates rt[2];
//--- ֻһн
   if(CopyRates(_Symbol,_Period,0,2,rt)!=2)
     {
      Print("CopyRates of ",_Symbol," ʧ, ûʷ");
      return;
     }
   if(rt[1].tick_volume>1) return;
//--- ȡõǰƶƽֵ 
   double   ma[1];
   if(CopyBuffer(ExtHandle,0,0,1,ma)!=1)
     {
      Print(" iMA CopyBuffer ʧ, û");
      return;
     }
//--- ź
   ENUM_ORDER_TYPE signal=WRONG_VALUE;

   if(rt[0].open>ma[0] && rt[0].close<ma[0]) signal=ORDER_TYPE_SELL;    // 
   else
      if(rt[0].open<ma[0] && rt[0].close>ma[0]) signal=ORDER_TYPE_BUY;  // 
//--- ļ
   if(signal!=WRONG_VALUE)
      if(TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))
         if(Bars(_Symbol,_Period)>100)
           {
            CTrade trade;
            trade.PositionOpen(_Symbol,signal,TradeSizeOptimized(),
                               SymbolInfoDouble(_Symbol,signal==ORDER_TYPE_SELL ? SYMBOL_BID:SYMBOL_ASK),
                               0,0);
           }
//---
  }
//+------------------------------------------------------------------+
//| ƽ                              |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   MqlRates rt[2];
//--- ֻһн
   if(CopyRates(_Symbol,_Period,0,2,rt)!=2)
     {
      Print("CopyRates of ",_Symbol," ʧ, ûʷ");
      return;
     }
   if(rt[1].tick_volume>1) return;
//--- ȡõǰƶƽֵ 
   double   ma[1];
   if(CopyBuffer(ExtHandle,0,0,1,ma)!=1)
     {
      Print(" iMA CopyBuffer ʧ, û");
      return;
     }
//--- ֮ǰѾѡ˲λ
   bool signal=false;
   long type=PositionGetInteger(POSITION_TYPE);

   if(type==(long)POSITION_TYPE_BUY   && rt[0].open>ma[0] && rt[0].close<ma[0]) signal=true;
   if(type==(long)POSITION_TYPE_SELL  && rt[0].open<ma[0] && rt[0].close>ma[0]) signal=true;
//--- ļ
   if(signal)
      if(TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))
         if(Bars(_Symbol,_Period)>100)
           {
            CTrade trade;
            trade.PositionClose(_Symbol,3);
           }
//---
  }
//+------------------------------------------------------------------+
//| EA ʼ                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   ExtHandle=iMA(_Symbol,_Period,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE);
   if(ExtHandle==INVALID_HANDLE)
     {
      printf(" MA ָ");
      return(-1);
     }
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| EA                                              |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(PositionSelect(_Symbol)) CheckForClose();
   else                        CheckForOpen();
//---
  }
//+------------------------------------------------------------------+
//| EA ȥʼ                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }

//--- ΪŻѴϵ
#include <FrameGenerator.mqh>
//--- ֡
CFrameGenerator fg;
//+------------------------------------------------------------------+
//| Tester                                                   |
//+------------------------------------------------------------------+
double OnTester()
  {
//--- ڴ˴Ż㺯
   double TesterCritetia=MathAbs(TesterStatistics(STAT_SHARPE_RATIO)*TesterStatistics(STAT_PROFIT));
   TesterCritetia=TesterStatistics(STAT_PROFIT)>0?TesterCritetia:(-TesterCritetia);
//--- ÿԺðŻΪύ
   fg.OnTester(TesterCritetia);
//---
   return(TesterCritetia);
  }
//+------------------------------------------------------------------+
//| TesterInit                                               |
//+------------------------------------------------------------------+
void OnTesterInit()
  {
//--- ׼ʾߵͼ
   fg.OnTesterInit(3); // ˲ͼϵߵ
  }
//+------------------------------------------------------------------+
//| TesterPass                                              |
//+------------------------------------------------------------------+
void OnTesterPass()
  {
//--- õĲԽʾͼ
   fg.OnTesterPass();
  }
//+------------------------------------------------------------------+
//| TesterDeinit                                             |
//+------------------------------------------------------------------+
void OnTesterDeinit()
  {
//--- Ż
   fg.OnTesterDeinit();
  }
//+------------------------------------------------------------------+
//|  ͼ¼                                           |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
//--- Ż󵱵̧ͷʱʾ֡
   fg.OnChartEvent(id,lparam,dparam,sparam,100); // 100 ڽȡ֮ԺΪλͣʱ
  }
//+------------------------------------------------------------------+
